"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const dotenv = __importStar(require("dotenv"));
const envalid_1 = __importDefault(require("envalid"));
dotenv.config();
const env = envalid_1.default.cleanEnv(process.env, {
    PORT: envalid_1.default.num({ default: 6000 }),
    LOG_LEVEL: envalid_1.default.str({ default: 'info' }),
    SHUTDOWN_POLLING_INTERVAL: envalid_1.default.num({ default: 60 }),
    STATS_POLLING_INTERVAL: envalid_1.default.num({ default: 30 }),
    GRACEFUL_SHUTDOWN_SCRIPT: envalid_1.default.str({ default: '/usr/local/bin/graceful_shutdown.sh' }),
    TERMINATE_SCRIPT: envalid_1.default.str({ default: '/usr/local/bin/terminate_instance.sh' }),
    RECONFIGURE_SCRIPT: envalid_1.default.str({ default: '/usr/local/bin/reconfigure_instance.sh' }),
    ASAP_JWT_ISS: envalid_1.default.str({ default: 'jitsi-autoscaler-sidecar' }),
    ASAP_JWT_AUD: envalid_1.default.str({ default: 'jitsi-autoscaler' }),
    ENABLE_REPORT_STATS: envalid_1.default.bool({ default: false }),
    POLLING_URL: envalid_1.default.str(),
    STATUS_URL: envalid_1.default.str(),
    STATS_RETRIEVE_URL: envalid_1.default.str({ default: '' }),
    STATS_REPORT_URL: envalid_1.default.str({ default: '' }),
    INSTANCE_ID: envalid_1.default.str(),
    INSTANCE_TYPE: envalid_1.default.str(),
    INSTANCE_METADATA: envalid_1.default.json({ default: '{}' }),
    ASAP_SIGNING_KEY_FILE: envalid_1.default.str(),
    ASAP_JWT_KID: envalid_1.default.str()
});
if (env.ENABLE_REPORT_STATS) {
    if (!env.STATS_RETRIEVE_URL || !env.STATS_REPORT_URL) {
        throw new Error('Stats reporting requires missing env vars: STATS_RETRIEVE_URL and STATS_REPORT_URL');
    }
}
exports.default = {
    HTTPServerPort: env.PORT,
    LogLevel: env.LOG_LEVEL,
    // number of seconds to wait between polling for shutdown
    ShutdownPollingInterval: env.SHUTDOWN_POLLING_INTERVAL,
    PollingURL: env.POLLING_URL,
    StatusURL: env.STATUS_URL,
    // number of seconds to wait before polling for stats
    StatsPollingInterval: env.STATS_POLLING_INTERVAL,
    EnableReportStats: env.ENABLE_REPORT_STATS,
    StatsRetrieveURL: env.STATS_RETRIEVE_URL,
    StatsReportURL: env.STATS_REPORT_URL,
    GracefulShutdownScript: env.GRACEFUL_SHUTDOWN_SCRIPT,
    TerminateScript: env.TERMINATE_SCRIPT,
    ReconfigureScript: env.RECONFIGURE_SCRIPT,
    InstanceId: env.INSTANCE_ID,
    InstanceMetadata: env.INSTANCE_METADATA,
    InstanceType: env.INSTANCE_TYPE,
    AsapSigningKeyFile: env.ASAP_SIGNING_KEY_FILE,
    AsapJwtKid: env.ASAP_JWT_KID,
    AsapJwtIss: env.ASAP_JWT_ISS,
    AsapJwtAud: env.ASAP_JWT_AUD
};
//# sourceMappingURL=config.js.map